(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-valdemort', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-valdemort'] = {}, global.ng.core, global.ng.forms, global.ng.common));
}(this, (function (exports, i0, i3, i4) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);

    /* eslint-disable @angular-eslint/directive-selector,@angular-eslint/no-input-rename */
    /**
     * Directive allowing to define the template for an error of a given type (using the `valError` input), using an ng-template.
     * It's used inside the body of the validation errors component, or inside the body of the default validation errors directive.
     * See the documentation of these two for example usages.
     */
    var ValidationErrorDirective = /** @class */ (function () {
        function ValidationErrorDirective(templateRef) {
            this.templateRef = templateRef;
            /**
             * The type of the error that the content of the template must display.
             */
            this.type = '';
        }
        return ValidationErrorDirective;
    }());
    ValidationErrorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValidationErrorDirective, deps: [{ token: i0__namespace.TemplateRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ValidationErrorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.0", type: ValidationErrorDirective, selector: "ng-template[valError]", inputs: { type: ["valError", "type"] }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValidationErrorDirective, decorators: [{
                type: i0.Directive,
                args: [{ selector: 'ng-template[valError]' }]
            }], ctorParameters: function () { return [{ type: i0__namespace.TemplateRef }]; }, propDecorators: { type: [{
                    type: i0.Input,
                    args: ['valError']
                }] } });

    /* eslint-disable @angular-eslint/directive-selector,@angular-eslint/no-input-rename */
    /**
     * Directive allowing to define a fallback template for an error of a type that is not handled by any validation error directive.
     * It's used inside the body of the validation errors component, or inside the body of the default validation errors directive.
     * See the documentation of these two for example usages.
     *
     * This is useful to handle forgotten errors instead of displaying no error at all, or to handle all or several error types in the same way,
     * for example by relying on the error key to choose an internationalized message.
     */
    var ValidationFallbackDirective = /** @class */ (function () {
        function ValidationFallbackDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return ValidationFallbackDirective;
    }());
    ValidationFallbackDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValidationFallbackDirective, deps: [{ token: i0__namespace.TemplateRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ValidationFallbackDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.0", type: ValidationFallbackDirective, selector: "ng-template[valFallback]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValidationFallbackDirective, decorators: [{
                type: i0.Directive,
                args: [{ selector: 'ng-template[valFallback]' }]
            }], ctorParameters: function () { return [{ type: i0__namespace.TemplateRef }]; } });

    /**
     * Service used by the default validation errors directive to store the default error template references. This
     * service is injected in the validation errors component which displays the appropriate templates and provides their context.
     */
    var DefaultValidationErrors = /** @class */ (function () {
        function DefaultValidationErrors() {
            this.directives = [];
        }
        return DefaultValidationErrors;
    }());
    DefaultValidationErrors.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: DefaultValidationErrors, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    DefaultValidationErrors.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: DefaultValidationErrors, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: DefaultValidationErrors, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }] });

    /* eslint-disable @angular-eslint/directive-selector,@angular-eslint/no-host-metadata-property */
    /**
     * Directive allowing to register default templates for validation error messages. It's supposed to be used once,
     * typically in the root component. By using templates to do that, error messages can
     * - easily be i18ned
     * - easily use pipes
     * - easily use HTML
     * - easily be ordered
     *
     * Example usage:
     * ```
     *   <val-default-errors>
     *     <ng-template valError="required">This field is mandatory</ng-template>
     *     <ng-template valError="max" let-error="error">This field must be at most {{ error.max | number }}</ng-template>
     *   </val-default-errors>
     * ```
     *
     * Example usage where a label is used to make the messages less generic:
     * ```
     *   <val-default-errors>
     *     <ng-template valError="required" let-label>{{ label }} is mandatory</ng-template>
     *     <ng-template valError="max" let-error="error" let-label>{{ label }} must be at most {{ error.max | number }}</ng-template>
     *   </val-default-errors>
     * ```
     *
     * A fallback template can also be provided. This fallback template is used for all the errors that exist on the form control
     * but are not handled by any of the specific error templates:
     * ```
     *   <val-default-errors>
     *     <ng-template valError="required" let-label>{{ label }} is mandatory</ng-template>
     *     <ng-template valError="max" let-error="error" let-label>{{ label }} must be at most {{ error.max | number }}</ng-template>
     *     <ng-template valFallback let-label let-type="type" let-error="error">{{ label }} has an unhandled error of type {{ type }}: {{ error | json }}</ng-template>
     *   </val-default-errors>
     * ```
     * Using the fallback can also be used to handle all the errors the same way, for example by using the error type as an i18n key
     * to display the appropriate error message.
     *
     * This directive stores the default template references in a service, that is then injected in the validation errors components
     * to be reused.
     */
    var DefaultValidationErrorsDirective = /** @class */ (function () {
        function DefaultValidationErrorsDirective(defaultValidationErrors) {
            this.defaultValidationErrors = defaultValidationErrors;
        }
        DefaultValidationErrorsDirective.prototype.ngAfterContentInit = function () {
            this.defaultValidationErrors.directives = this.errorDirectives.toArray();
            this.defaultValidationErrors.fallback = this.fallbackDirective;
        };
        return DefaultValidationErrorsDirective;
    }());
    DefaultValidationErrorsDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: DefaultValidationErrorsDirective, deps: [{ token: DefaultValidationErrors }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    DefaultValidationErrorsDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.0", type: DefaultValidationErrorsDirective, selector: "val-default-errors", host: { styleAttribute: "display: none" }, queries: [{ propertyName: "fallbackDirective", first: true, predicate: ValidationFallbackDirective, descendants: true }, { propertyName: "errorDirectives", predicate: ValidationErrorDirective }], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: DefaultValidationErrorsDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'val-default-errors',
                        host: {
                            style: 'display: none'
                        }
                    }]
            }], ctorParameters: function () { return [{ type: DefaultValidationErrors }]; }, propDecorators: { errorDirectives: [{
                    type: i0.ContentChildren,
                    args: [ValidationErrorDirective]
                }], fallbackDirective: [{
                    type: i0.ContentChild,
                    args: [ValidationFallbackDirective]
                }] } });

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    /**
     * The display mode of the validation errors. For a given control, either all the validation errors
     * are displayed, or only the first one.
     */
    exports.DisplayMode = void 0;
    (function (DisplayMode) {
        DisplayMode[DisplayMode["ALL"] = 0] = "ALL";
        DisplayMode[DisplayMode["ONE"] = 1] = "ONE";
    })(exports.DisplayMode || (exports.DisplayMode = {}));
    /**
     * The configuration service used by the validation errors component to apply common rules for all
     * form controls.
     *
     * To change its default behavior, you can either inject this service in your root module or component and mutate it,
     * or define your own implementation and provide it.
     */
    var ValdemortConfig = /** @class */ (function () {
        function ValdemortConfig() {
            /**
             * The display mode of the errors. The default value is ALL, meaning that all the errors existing on a control
             * (and which have an error template defined) are displayed.
             */
            this.displayMode = exports.DisplayMode.ALL;
            /**
             * Specifies one or several CSS classes (separated by a white space) that are automatically added to the
             * validation errors element. This can be useful to reuse a standard CSS class of your CSS framework (like
             * .invalid-feedback in BootStrap), rather than styling the val-errors element itself.
             *
             * The default value is null (no class is added).
             */
            this.errorsClasses = null;
            /**
             * Specifies one or several CSS classes (separated by a white space) that are automatically added to the
             * each validation error message element. This can be useful to reuse a standard CSS class of your CSS framework
             * rather than styling the div element itself.
             *
             * The default value is null (no class is added).
             */
            this.errorClasses = null;
            /**
             * Specifies when error messages should be displayed. based on the state of the control itself (touched, dirty, etc.)
             * and on the state of the form directive containing it (if any). This function is only called if the control is invalid
             * in the first place: if it's valid, errors are never displayed.
             *
             * The default value of this function returns true if the control is touched, or if the form (if any) is submitted.
             */
            this.shouldDisplayErrors = function (control, form) { return control.touched || (!!form && form.submitted); };
            /**
             * Specifies if the library should throw an error when a control is not found.
             * For example, this can happen if a typo was made in the `controlName`.
             * If the check is enabled, then an error will be thrown in such a case.
             * Otherwise, the error is silently ignored.
             *
             * The default value of this function returns false, thus disabling the check.
             *
             * You can enable the check by giving it a function that returns true,
             * or you can enable it only in development for example with:
             * `config.shouldThrowOnMissingControl = () => !environment.production`
             */
            this.shouldThrowOnMissingControl = function () { return false; };
        }
        return ValdemortConfig;
    }());
    ValdemortConfig.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortConfig, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    ValdemortConfig.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortConfig, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortConfig, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }] });

    /**
     * Component allowing to display validation error messages associated to a given form control, form group or form array.
     * The control is provided using the `control` input of the component. If it's used inside an enclosing form group or
     * form array, it can instead be provided using the `controlName` input of the component.
     *
     * Example usage where the control itself is being passed as input:
     * ```
     *   <val-errors [control]="form.get('birthDate')">
     *     <ng-template valError="required">The birth date is mandatory</ng-template>
     *     <ng-template valError="max" let-error="error">The max value for the birth date is {{ error.max | number }}</ng-template>
     *   </val-errors>
     * ```
     *
     * Example usage where the control name is being passed as input:
     * ```
     *   <val-errors controlName="birthDate">
     *     <ng-template valError="required">The birth date is mandatory</ng-template>
     *     <ng-template valError="max" let-error="error">The max value for the birth date is {{ error.max | number }}</ng-template>
     *   </val-errors>
     * ```
     *
     * This component, if the control is invalid, displays its validation errors using the provided templates.
     * The templates, as shown in the above example, have access to the validation error itself.
     *
     * The label of the control can also be provided as input, and then used in the templates:
     * ```
     *   <val-errors controlName="birthDate" label="the birth date">
     *     <ng-template valError="required" let-label>{{ label }} is mandatory</ng-template>
     *     <ng-template valError="max" let-error="error" let-label>The max value for {{ label }} is {{ error.max | number }}</ng-template>
     *   </val-errors>
     * ```
     *
     * The component‘s behavior is configured globally by the Config service (see its documentation for more details). It can
     * - display the first error, or all the errors
     * - add CSS classes to its host `<val-errors>` element
     * - add CSS classes to each error message element being displayed
     * - choose when to display the errors (dirty, touched, touched and submitted, etc.)
     *
     * Global, default templates can be defined (and used by this component) using the default validation errors directive
     * (see its documentation for details). So, if the default error messages are defined and sufficient for a given control, all you
     * need is
     *
     * ```
     * <val-errors controlName="birthDate"></val-errors>
     * ```
     *
     * or, if the default templates expect a label:
     *
     * ```
     * <val-errors controlName="birthDate" label="the birth date"></val-errors>
     * ```
     *
     * If, however, you want to override one or several error messages by custom ones, you can do so by simply defining them inside the
     * component:
     *
     * ```
     * <val-errors controlName="birthDate" label="the birth date">
     *   <ng-template valError="max">You're too young, sorry</ng-template>
     * </val-errors>
     * ```
     *
     * A fallback template can also be provided. This fallback template is used for all the errors that exist on the form control
     * but are not handled by any of the specific error templates:
     * ```
     * <val-errors controlName="birthDate" label="the birth date">
     *   <ng-template valError="max">You're too young, sorry</ng-template>
     *   <ng-template valFallback let-label let-type="type" let-error="error">{{ label }} has an unhandled error of type {{ type }}: {{ error | json }}</ng-template>
     * </val-errors>
     * ```
     * Note that, the fallback template can also be defined in the default validation errors directive (see its documentation for details).
     * If a fallback template is defined inside `val-errors`, it overrides the default fallback.
     *
     * If an error is present on the control, but doesn't have any template, default template or fallback template defined for its type,
     * then it's not displayed. If the control is valid, or if none of the errors of the component has a matching template or default template,
     * then this component itself is hidden.
     */
    var ValidationErrorsComponent = /** @class */ (function () {
        /**
         * @param config the Config service instance, defining the behavior of this component
         * @param defaultValidationErrors the service holding the default error templates, optionally
         * defined by using the default validation errors directive
         * @param controlContainer one of the 4 form group or form array directives that can "wrap" the control.
         * It's injected so that we can know if it exists and, if it does, if its form directive has been submitted or not:
         * the config service shouldDisplayErrors function can choose (and does by default) to use that information.
         */
        function ValidationErrorsComponent(config, defaultValidationErrors, controlContainer) {
            this.config = config;
            this.defaultValidationErrors = defaultValidationErrors;
            this.controlContainer = controlContainer;
            /**
             * The FormControl, FormGroup or FormArray containing the validation errors.
             * If set, the controlName input is ignored
             */
            this.control = null;
            /**
             * The name (or the index, in case it's contained in a FormArray) of the FormControl, FormGroup or FormArray containing the validation
             * errors.
             * Ignored if the control input is set, and only usable if the control to validate is part of a control container
             */
            this.controlName = null;
            /**
             * The label of the field, exposed to templates so they can use it in the error message.
             */
            this.label = null;
        }
        Object.defineProperty(ValidationErrorsComponent.prototype, "shouldDisplayErrors", {
            get: function () {
                var ctrl = this.actualControl;
                if (!ctrl || !ctrl.invalid || !this.hasDisplayableError(ctrl)) {
                    return false;
                }
                var form = this.controlContainer && this.controlContainer.formDirective;
                return this.config.shouldDisplayErrors(ctrl, form);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ValidationErrorsComponent.prototype, "errorsClasses", {
            get: function () {
                return this.config.errorsClasses || '';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ValidationErrorsComponent.prototype, "errorClasses", {
            get: function () {
                return this.config.errorClasses || '';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ValidationErrorsComponent.prototype, "errorsToDisplay", {
            get: function () {
                var _this = this;
                var _a, _b;
                var mergedDirectives = [];
                var fallbackErrors = [];
                var alreadyMetTypes = new Set();
                var shouldContinue = function () { return _this.config.displayMode === exports.DisplayMode.ALL || (mergedDirectives.length === 0 && fallbackErrors.length === 0); };
                var ctrl = this.actualControl;
                var _loop_1 = function (i) {
                    var defaultDirective = this_1.defaultValidationErrors.directives[i];
                    if (ctrl.hasError(defaultDirective.type)) {
                        var customDirectiveOfSameType = this_1.errorDirectives.find(function (dir) { return dir.type === defaultDirective.type; });
                        mergedDirectives.push(customDirectiveOfSameType || defaultDirective);
                    }
                    alreadyMetTypes.add(defaultDirective.type);
                };
                var this_1 = this;
                for (var i = 0; i < this.defaultValidationErrors.directives.length && shouldContinue(); i++) {
                    _loop_1(i);
                }
                if (shouldContinue()) {
                    var customDirectives = this.errorDirectives.toArray();
                    for (var i = 0; i < customDirectives.length && shouldContinue(); i++) {
                        var customDirective = customDirectives[i];
                        if (ctrl.hasError(customDirective.type) && !alreadyMetTypes.has(customDirective.type)) {
                            mergedDirectives.push(customDirective);
                        }
                        alreadyMetTypes.add(customDirective.type);
                    }
                }
                if (shouldContinue() && (this.fallbackDirective || this.defaultValidationErrors.fallback)) {
                    var allErrors = Object.entries((_a = ctrl.errors) !== null && _a !== void 0 ? _a : []);
                    for (var i = 0; i < allErrors.length && shouldContinue(); i++) {
                        var _c = __read(allErrors[i], 2), type = _c[0], value = _c[1];
                        if (!alreadyMetTypes.has(type)) {
                            fallbackErrors.push({ type: type, value: value });
                        }
                    }
                }
                return {
                    errors: mergedDirectives,
                    fallback: (_b = this.fallbackDirective) !== null && _b !== void 0 ? _b : this.defaultValidationErrors.fallback,
                    fallbackErrors: fallbackErrors
                };
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ValidationErrorsComponent.prototype, "actualControl", {
            get: function () {
                var _a, _b;
                if (this.control) {
                    return this.control;
                }
                else if ((this.controlName || this.controlName === 0) && ((_a = this.controlContainer.control) === null || _a === void 0 ? void 0 : _a.controls)) {
                    var control = this.controlContainer.control.controls[this.controlName];
                    if (this.config.shouldThrowOnMissingControl()) {
                        // if the control is null, then there are two cases:
                        // - we are in a template driven form, and the controls might not be initialized yet
                        // - there was an error in the control name. If so, let's throw an error to help developers
                        // to avoid false positive in template driven forms, we check if the controls are initialized
                        // by checking if the `controls` object or array has any element
                        if (!control && Object.keys((_b = this.controlContainer.control) === null || _b === void 0 ? void 0 : _b.controls).length > 0) {
                            throw new Error("ngx-valdemort: no control found for controlName: '" + this.controlName + "'.");
                        }
                    }
                    return control;
                }
                return null;
            },
            enumerable: false,
            configurable: true
        });
        ValidationErrorsComponent.prototype.hasDisplayableError = function (ctrl) {
            var _this = this;
            return (ctrl.errors &&
                (this.fallbackDirective ||
                    this.defaultValidationErrors.fallback ||
                    Object.keys(ctrl.errors).some(function (type) { return _this.defaultValidationErrors.directives.some(function (dir) { return dir.type === type; }) || _this.errorDirectives.some(function (dir) { return dir.type === type; }); })));
        };
        return ValidationErrorsComponent;
    }());
    ValidationErrorsComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValidationErrorsComponent, deps: [{ token: ValdemortConfig }, { token: DefaultValidationErrors }, { token: i3__namespace.ControlContainer, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Component });
    ValidationErrorsComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.0", type: ValidationErrorsComponent, selector: "val-errors", inputs: { control: "control", controlName: "controlName", label: "label" }, host: { properties: { "class": "errorsClasses", "style.display": "shouldDisplayErrors ? '' : 'none'" } }, queries: [{ propertyName: "fallbackDirective", first: true, predicate: ValidationFallbackDirective, descendants: true }, { propertyName: "errorDirectives", predicate: ValidationErrorDirective }], ngImport: i0__namespace, template: "<ng-container *ngIf=\"shouldDisplayErrors\">\n  <ng-container *ngIf=\"errorsToDisplay as e\">\n    <div [class]=\"errorClasses\" *ngFor=\"let errorDirective of e.errors\">\n      <ng-container\n        *ngTemplateOutlet=\"errorDirective!.templateRef; context: {\n        $implicit: label,\n        error: actualControl!.errors![errorDirective.type]\n      }\"\n      ></ng-container>\n    </div>\n    <div [class]=\"errorClasses\" *ngFor=\"let error of e.fallbackErrors\">\n      <ng-container\n        *ngTemplateOutlet=\"e.fallback!.templateRef; context: {\n        $implicit: label,\n        type: error.type,\n        error: error.value\n      }\"\n      ></ng-container>\n    </div>\n  </ng-container>\n</ng-container>\n", directives: [{ type: i4__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i4__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i4__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValidationErrorsComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'val-errors',
                        templateUrl: './validation-errors.component.html',
                        host: {
                            '[class]': 'errorsClasses',
                            '[style.display]': "shouldDisplayErrors ? '' : 'none'"
                        }
                    }]
            }], ctorParameters: function () {
            return [{ type: ValdemortConfig }, { type: DefaultValidationErrors }, { type: i3__namespace.ControlContainer, decorators: [{
                            type: i0.Optional
                        }] }];
        }, propDecorators: { control: [{
                    type: i0.Input
                }], controlName: [{
                    type: i0.Input
                }], label: [{
                    type: i0.Input
                }], errorDirectives: [{
                    type: i0.ContentChildren,
                    args: [ValidationErrorDirective]
                }], fallbackDirective: [{
                    type: i0.ContentChild,
                    args: [ValidationFallbackDirective]
                }] } });

    var ValdemortModule = /** @class */ (function () {
        function ValdemortModule() {
        }
        return ValdemortModule;
    }());
    ValdemortModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ValdemortModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortModule, declarations: [ValidationErrorsComponent, ValidationErrorDirective, ValidationFallbackDirective, DefaultValidationErrorsDirective], imports: [i4.CommonModule], exports: [ValidationErrorsComponent, ValidationErrorDirective, ValidationFallbackDirective, DefaultValidationErrorsDirective] });
    ValdemortModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortModule, imports: [[i4.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: ValdemortModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [i4.CommonModule],
                        declarations: [ValidationErrorsComponent, ValidationErrorDirective, ValidationFallbackDirective, DefaultValidationErrorsDirective],
                        exports: [ValidationErrorsComponent, ValidationErrorDirective, ValidationFallbackDirective, DefaultValidationErrorsDirective]
                    }]
            }] });

    /* eslint-disable */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DefaultValidationErrorsDirective = DefaultValidationErrorsDirective;
    exports.ValdemortConfig = ValdemortConfig;
    exports.ValdemortModule = ValdemortModule;
    exports.ValidationErrorDirective = ValidationErrorDirective;
    exports.ValidationErrorsComponent = ValidationErrorsComponent;
    exports.ValidationFallbackDirective = ValidationFallbackDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-valdemort.umd.js.map
